options linesize = 256 pagesize = 32000 orientation = landscape spool;

/* Basic branches are AD AG AR AV CM EN FA FI IN MI MP OD QM SC TC  */

filename cadet './ins/cadets.csv';
filename goal './ins/goal.txt';
/* read in the cadet data */

/* AD AG AR AV CM EN FA FI IN MI MP MS OD QM SC TC  */

/* read in branching data, see input statement for format and fields needed */

data cadets;
  infile cadet DLM=',' DSD MISSOVER;
  input OMS $ SEX $ RACE $ prevbr $ BR1 $ BR2 $ BR3 $ BR4 $ BR5 $ acd $ ; 
  if _N_ > 1;
  omsnbr = input(OMS,9.);
  ac = input(acd,9.);
  RCE='1';
  if RACE ne '1' then RCE='2';
  
run;
 
proc sort data=cadets;
by descending omsnbr;

data cadetsc;
  set cadets;
  RANK = _N_ ;
run;

proc sql; select count(*) into :fem_cnt from cadets where SEX='F'; quit;
proc sql; select count(*) as cnt into :all_cnt from cadets; quit;
proc sql; select avg(omsnbr) into :avg_oms from cadets; quit;

data branching_scores;
  set cadetsc;
  AD=1.0000;
  AG=1.0000;
  AR=1.0000;
  AV=1.0000;
  CM=1.0000;
  EN=1.0000;
  FA=1.0000;
  FI=1.0000;
  IN=1.0000;
  MI=1.0000;
  MP=1.0000;
  MS=1.0000;
  OD=1.0000;
  QM=1.0000;
  SC=1.0000;
  TC=1.0000;
  IN=1.0000;
  if br1 = 'IN' then IN=IN+5;
  if br1 = 'AR' then AR=AR+5;
  if br1 = 'FA' then FA=FA+5;
  if br1 = 'AD' then AD=AD+5;
  if br1 = 'AV' then AV=AV+5;
  if br1 = 'EN' then EN=EN+5;
  if br1 = 'CM' then CM=CM+5;
  if br1 = 'SC' then SC=SC+5;
  if br1 = 'MI' then MI=MI+5;
  if br1 = 'MP' then MP=MP+5;
  if br1 = 'MS' then MS=MS+5;
  if br1 = 'AG' then AG=AG+5;
  if br1 = 'FI' then FI=FI+5;
  if br1 = 'TC' then TC=TC+5;
  if br1 = 'OD' then OD=OD+5;
  if br1 = 'QM' then QM=QM+5;
  if br2 = 'IN' and br1 ne 'IN' then IN=IN+4;
  if br2 = 'AR' and br1 ne 'AR' then AR=AR+4;
  if br2 = 'FA' and br1 ne 'FA' then FA=FA+4;
  if br2 = 'AD' and br1 ne 'AD' then AD=AD+4;
  if br2 = 'AV' and br1 ne 'AV' then AV=AV+4;
  if br2 = 'EN' and br1 ne 'EN' then EN=EN+4;
  if br2 = 'CM' and br1 ne 'CM' then CM=CM+4;
  if br2 = 'SC' and br1 ne 'SC' then SC=SC+4;
  if br2 = 'MI' and br1 ne 'MI' then MI=MI+4;
  if br2 = 'MP' and br1 ne 'MP' then MP=MP+4;
  if br2 = 'MS' and br1 ne 'MS' then MS=MS+4;
  if br2 = 'AG' and br1 ne 'AG' then AG=AG+4;
  if br2 = 'FI' and br1 ne 'FI' then FI=FI+4;
  if br2 = 'TC' and br1 ne 'TC' then TC=TC+4;
  if br2 = 'OD' and br1 ne 'OD' then OD=OD+4;
  if br2 = 'QM' and br1 ne 'QM' then QM=QM+4;
  if br3 = 'IN' and br1 ne 'IN' and br2 ne 'IN' then IN=IN+3;
  if br3 = 'AR' and br1 ne 'AR' and br2 ne 'AR' then AR=AR+3;
  if br3 = 'FA' and br1 ne 'FA' and br2 ne 'FA' then FA=FA+3;
  if br3 = 'AD' and br1 ne 'AD' and br2 ne 'AD' then AD=AD+3;
  if br3 = 'AV' and br1 ne 'AV' and br2 ne 'AV' then AV=AV+3;
  if br3 = 'EN' and br1 ne 'EN' and br2 ne 'EN' then EN=EN+3;
  if br3 = 'CM' and br1 ne 'CM' and br2 ne 'CM' then CM=CM+3;
  if br3 = 'SC' and br1 ne 'SC' and br2 ne 'SC' then SC=SC+3;
  if br3 = 'MI' and br1 ne 'MI' and br2 ne 'MI' then MI=MI+3;
  if br3 = 'MP' and br1 ne 'MP' and br2 ne 'MP' then MP=MP+3;
  if br3 = 'MS' and br1 ne 'MS' and br2 ne 'MS' then MS=MS+3;
  if br3 = 'AG' and br1 ne 'AG' and br2 ne 'AG' then AG=AG+3;
  if br3 = 'FI' and br1 ne 'FI' and br2 ne 'FI' then FI=FI+3;
  if br3 = 'TC' and br1 ne 'TC' and br2 ne 'TC' then TC=TC+3;
  if br3 = 'OD' and br1 ne 'OD' and br2 ne 'OD' then OD=OD+3;
  if br3 = 'QM' and br1 ne 'QM' and br2 ne 'QM' then QM=QM+3;
  if br4 = 'IN' and br1 ne 'IN' and br2 ne 'IN' and br3 ne 'IN' then IN=IN+2;
  if br4 = 'AR' and br1 ne 'AR' and br2 ne 'AR' and br3 ne 'AR' then AR=AR+2;
  if br4 = 'FA' and br1 ne 'FA' and br2 ne 'FA' and br3 ne 'FA' then FA=FA+2;
  if br4 = 'AD' and br1 ne 'AD' and br2 ne 'AD' and br3 ne 'AD' then AD=AD+2;
  if br4 = 'AV' and br1 ne 'AV' and br2 ne 'AV' and br3 ne 'AV' then AV=AV+2;
  if br4 = 'EN' and br1 ne 'EN' and br2 ne 'EN' and br3 ne 'EN' then EN=EN+2;
  if br4 = 'CM' and br1 ne 'CM' and br2 ne 'CM' and br3 ne 'CM' then CM=CM+2;
  if br4 = 'SC' and br1 ne 'SC' and br2 ne 'SC' and br3 ne 'SC' then SC=SC+2;
  if br4 = 'MI' and br1 ne 'MI' and br2 ne 'MI' and br3 ne 'MI' then MI=MI+2;
  if br4 = 'MP' and br1 ne 'MP' and br2 ne 'MP' and br3 ne 'MP' then MP=MP+2;
  if br4 = 'MS' and br1 ne 'MS' and br2 ne 'MS' and br3 ne 'MS' then MS=MS+2;
  if br4 = 'AG' and br1 ne 'AG' and br2 ne 'AG' and br3 ne 'AG' then AG=AG+2;
  if br4 = 'FI' and br1 ne 'FI' and br2 ne 'FI' and br3 ne 'FI' then FI=FI+2;
  if br4 = 'TC' and br1 ne 'TC' and br2 ne 'TC' and br3 ne 'TC' then TC=TC+2;
  if br4 = 'OD' and br1 ne 'OD' and br2 ne 'OD' and br3 ne 'OD' then OD=OD+2;
  if br4 = 'QM' and br1 ne 'QM' and br2 ne 'QM' and br3 ne 'QM' then QM=QM+2;
  if br5 = 'IN' and br1 ne 'IN' and br2 ne 'IN' and br3 ne 'IN' and br4 ne 'IN' then IN=IN+1;
  if br5 = 'AR' and br1 ne 'AR' and br2 ne 'AR' and br3 ne 'AR' and br4 ne 'AR' then  AR=AR+1;
  if br5 = 'FA' and br1 ne 'FA' and br2 ne 'FA' and br3 ne 'FA' and br4 ne 'FA' then  FA=FA+1;
  if br5 = 'AD' and br1 ne 'AD' and br2 ne 'AD' and br3 ne 'AD' and br4 ne 'AD' then  AD=AD+1;
  if br5 = 'AV' and br1 ne 'AV' and br2 ne 'AV' and br3 ne 'AV' and br4 ne 'AV' then  AV=AV+1;
  if br5 = 'EN' and br1 ne 'EN' and br2 ne 'EN' and br3 ne 'EN' and br4 ne 'EN' then  EN=EN+1;
  if br5 = 'CM' and br1 ne 'CM' and br2 ne 'CM' and br3 ne 'CM' and br4 ne 'CM' then  CM=CM+1;
  if br5 = 'SC' and br1 ne 'SC' and br2 ne 'SC' and br3 ne 'SC' and br4 ne 'SC' then  SC=SC+1;
  if br5 = 'MI' and br1 ne 'MI' and br2 ne 'MI' and br3 ne 'MI' and br4 ne 'MI' then  MI=MI+1;
  if br5 = 'MP' and br1 ne 'MP' and br2 ne 'MP' and br3 ne 'MP' and br4 ne 'MP' then  MP=MP+1;
  if br5 = 'MS' and br1 ne 'MS' and br2 ne 'MS' and br3 ne 'MS' and br4 ne 'MP' then  MS=MS+1;
  if br5 = 'AG' and br1 ne 'AG' and br2 ne 'AG' and br3 ne 'AG' and br4 ne 'AG' then  AG=AG+1;
  if br5 = 'FI' and br1 ne 'FI' and br2 ne 'FI' and br3 ne 'FI' and br4 ne 'FI' then  FI=FI+1;
  if br5 = 'TC' and br1 ne 'TC' and br2 ne 'TC' and br3 ne 'TC' and br4 ne 'TC' then  TC=TC+1;
  if br5 = 'OD' and br1 ne 'OD' and br2 ne 'OD' and br3 ne 'OD' and br4 ne 'OD' then  OD=OD+1;
  if br5 = 'QM' and br1 ne 'QM' and br2 ne 'QM' and br3 ne 'QM' and br4 ne 'QM' then  QM=QM+1;
  IN = IN/RANK;
  AR = AR/RANK;
  FA = FA/RANK;
  AD = AD/RANK;
  AV = AV/RANK;
  EN = EN/RANK;
  CM = CM/RANK;
  SC = SC/RANK;
  MI = MI/RANK;
  MP = MP/RANK;
  MS = MS/RANK;
  AG = AG/RANK;
  FI = FI/RANK;
  TC = TC/RANK;
  OD = OD/RANK;
  QM = QM/RANK;
run;

data bs(keep=RANK OMS SEX RACE RCE ACD AD AG AR AV CM EN FA FI IN MI MP MS OD QM SC TC);
  set branching_scores;
run;

title 'print data=branching_scores;';
proc print data=branching_scores;
run;
title ' ';

/* read in goal data */
data goalst;
  infile goal missover;
  input BR $1-2 goal $ ;
  goalnbr = input(goal,5.);
run;

proc sql; select sum(goalnbr) as cnt into :ca_cnt from goalst where BR in ('IN','AR','FA'); quit;

data goals;
  set goalst;
  if BR in ('MS') then goalnbr = 0;
  femgoals=round(goalnbr * &fem_cnt/(&all_cnt-&ca_cnt),1);
  if BR in ('IN' 'AR' 'FA') then femgoals = 0;
  qgoals=0.998*goalnbr*&avg_oms;
  _sd_ = -1 * goalnbr ;
  _node_ = BR;
run;

/* AD AG AR AV CM EN FA FI IN MI MP MS OD QM SC TC  */

proc sql;
  create table goal_data as
  select lower(_node_) as _node_, _sd_
    from goals;
quit;

proc print data=goal_data;
run;



/* AD AG AR AV CM EN FA FI IN MI MP MS OD QM SC TC  */
proc sql;
  create table arcd as
  select put(RANK,8.) as _from_, AD as _cost_, put(RANK,8.) || '_ad' as _name_ 
    from bs
  union
  select put(RANK,8.) as _from_, AG as _cost_, put(RANK,8.) || '_ag' as _name_ 
    from bs
  union
  select put(RANK,8.) as _from_, AR as _cost_, put(RANK,8.) || '_ar' as _name_ 
    from bs
  union
  select put(RANK,8.) as _from_, AV as _cost_, put(RANK,8.) || '_av' as _name_ 
    from bs
  union
  select put(RANK,8.) as _from_, CM as _cost_, put(RANK,8.) || '_cm' as _name_ 
    from bs
  union
  select put(RANK,8.) as _from_, EN as _cost_, put(RANK,8.) || '_en' as _name_ 
    from bs
  union
  select put(RANK,8.) as _from_, FA as _cost_, put(RANK,8.) || '_fa' as _name_ 
    from bs
  union
  select put(RANK,8.) as _from_, FI as _cost_, put(RANK,8.) || '_fi' as _name_ 
    from bs
  union
  select put(RANK,8.) as _from_, IN as _cost_, put(RANK,8.) || '_in' as _name_ 
    from bs
  union
  select put(RANK,8.) as _from_, MI as _cost_, put(RANK,8.) || '_mi' as _name_ 
    from bs
  union
  select put(RANK,8.) as _from_, MP as _cost_, put(RANK,8.) || '_mp' as _name_ 
    from bs
  union
  select put(RANK,8.) as _from_, MS as _cost_, put(RANK,8.) || '_ms' as _name_ 
    from bs
  union
  select put(RANK,8.) as _from_, OD as _cost_, put(RANK,8.) || '_od' as _name_ 
    from bs
  union
  select put(RANK,8.) as _from_, QM as _cost_, put(RANK,8.) || '_qm' as _name_ 
    from bs
  union
  select put(RANK,8.) as _from_, SC as _cost_, put(RANK,8.) || '_sc' as _name_ 
    from bs
  union
  select put(RANK,8.) as _from_, TC as _cost_, put(RANK,8.) || '_tc' as _name_ 
    from bs
;
quit;

data arc_data;
  set arcd;
  _to_ = substr(_name_, index(_name_,'_')+1,2);
  _capac_ = 1;
  _lo_ = . ;
run;


title 'proc print data=arc_data;';
proc print data=arc_data;
run;
title '';

proc sql;
  create table node_data as
  select _node_, _sd_ from goal_data 
    union
  select put(rank,8.) as _node_, input('1',6.) as _sd_
    from bs  
;
quit;


proc sql;
  title 'node_data output';
  select * from node_data;
quit;

proc sql;
  title 'arc_data output';
  select * from arc_data;
quit;

proc netflow maximize
  nodedata=node_data
  arcdata=arc_data
  arcout=sol;
  reset maxit1 = 30000;
run;

proc sql;
  create table assignments as
  select input(_from_,8.) as RANK,
    upper(substr(_to_,1,2)) as assigned,
	put(_cost_,10.8) as cost
    from sol
    where _FLOW_ > 0
    and _from_ < '99999';
quit;

proc sql;
  title 'assignments';
  select * from assignments;
  title;
quit;

proc sort data=assignments; by rank;
proc sort data=cadetsc; by rank;

data result1;
/*(keep=rank sex race prevbr assigned br1 br2 br3 br4 br5 choice pbmatch cost) ; */
  merge cadetsc(in=ina) assignments(in=inb);
    by RANK;
  choice = 'other';
  choice = 'other';
  if assigned = br1 then choice = '1st';
  else if assigned = br2 then choice = '2nd';
  else if assigned = br3 then choice = '3rd';
  else if assigned = br4 then choice = '4th';
  else if assigned = br5 then choice = '5th';
run;

proc sql;
  create table result as
  select rank, sex, race, oms, cost, assigned, br1, br2, br3, br4, br5, choice
    from result1
    order by rank;
quit;


/* create Excel .csv file of the data requested    */
ods csv file='./outn1/answer.csv';
proc print data=result noobs;
run;
ods csv close;

proc sql; select count(*) as cnt into :all_cnt from cadets; quit;

proc sql;
  create table satisfy1 as
  select choice, count(*) as sat
    from result
        group by choice
        order by sat descending;
quit;

data sat1;
  set satisfy1;
  satstat=100*sat/&all_cnt;
run;

proc sort data=sat1;
  by choice;

data sat2;
  set sat1;
  retain cumstat;
  cumstat=sum(satstat,cumstat);
run;

proc sort data=sat2;
  by choice;

proc sql;
  create table satisfied as
  select choice, sat as count, satstat as satisfied, cumstat as cumulative
    from sat2
    order by choice;
quit;

title 'Overall percents';
proc freq data=result;
  tables choice assigned / out=freqs;
run;
title ' ';

title 'Satisfaction';
proc freq data=result order=freq ;
  tables choice / out=satisfy;
run;
title ' ';

proc print data=satisfy;
run;

proc sort data=freqs;
  by assigned;

proc sql;
  create table gd as
  select upper(_node_) as _node_, (-1 * _sd_) as goal 
    from goal_data
    order by _node_;
quit;

data freqsgoals;
  merge freqs(rename=(assigned=br)) gd(rename=(_node_=br));
  by br;
run;

data fems;
  set result;
  if sex = 'F';
run;

data minorities;
  set result;
  if race ne 'C';
run;

title 'Female percents';
proc freq data=fems;
  tables  choice assigned / out=femsperc;
run;
title ' ';

proc sort data=femsperc;
  by assigned;

proc sql;
  create table quality as 
  select assigned, avg(input(oms,8.)) as avg_oms
    from result
    group by assigned
    order by avg_oms descending;
quit;

proc sql;
  title 'Quality per Branch';
  select *
    from quality
    order by avg_oms descending;
  title;
quit;

ods csv file='./outo1/goals.csv';
proc print data=goals noobs;
run;
ods csv close;

/* create Excel .csv file of the data requested    */
ods csv file='./outn1/freqs.csv';
proc print data=freqsgoals noobs;
run;
ods csv close;

/* create Excel .csv file of the data requested    */
ods csv file='./outn1/satisfied.csv';
proc print data=satisfied noobs;
run;
ods csv close;

/* create Excel .csv file of the data requested    */
ods csv file='./outn1/quality.csv';
proc print data=quality noobs;
run;
ods csv close;

/* create Excel .csv file of the data requested    */
ods csv file='./outn1/femsperc.csv';
proc print data=femsperc noobs;
run;
ods csv close;

/* create Excel .csv file of the data requested    */
ods csv file='./outn1/results.csv';
proc print data=sol noobs;
run;
ods csv close;

